## AgsPluginPort

AgsPluginPort — The plugin port class

## Stability Level

Stable, unless otherwise indicated

## Functions

#define | AGS_PLUGIN_PORT_GET_OBJ_MUTEX()
GRecMutex * | ags_plugin_port_get_obj_mutex ()
gboolean | ags_plugin_port_test_flags ()
void | ags_plugin_port_set_flags ()
void | ags_plugin_port_unset_flags ()
guint | ags_plugin_port_get_port_index ()
void | ags_plugin_port_set_port_index ()
gchar * | ags_plugin_port_get_port_name ()
void | ags_plugin_port_set_port_name ()
gchar * | ags_plugin_port_get_port_symbol ()
void | ags_plugin_port_set_port_symbol ()
gint | ags_plugin_port_get_scale_steps ()
void | ags_plugin_port_set_scale_steps ()
gchar ** | ags_plugin_port_get_scale_point ()
void | ags_plugin_port_set_scale_point ()
gdouble * | ags_plugin_port_get_scale_value ()
void | ags_plugin_port_set_scale_value ()
GValue * | ags_plugin_port_get_lower_value ()
void | ags_plugin_port_set_lower_value ()
GValue * | ags_plugin_port_get_upper_value ()
void | ags_plugin_port_set_upper_value ()
GValue * | ags_plugin_port_get_default_value ()
void | ags_plugin_port_set_default_value ()
GList * | ags_plugin_port_find_symbol ()
GList * | ags_plugin_port_find_port_index ()
AgsPluginPort * | ags_plugin_port_new ()

## Properties

gpointer | default-value | Read / Write
gpointer | lower-value | Read / Write
guint | port-index | Read / Write
char * | port-name | Read / Write
char * | port-symbol | Read / Write
gpointer | scale-point | Read
int | scale-steps | Read / Write
gpointer | scale-value | Read
gpointer | upper-value | Read / Write

## Types and Values

enum | AgsPluginPortFlags

## Object Hierarchy

        GFlags
        ╰── AgsPluginPortFlags
        GObject
        ╰── AgsPluginPort

## Includes

    #include <ags/plugin/ags_plugin_port.h>

## Description

The AgsPluginPort describes a plugin's port. For real ports used by the processing tree please take a look at AgsPort.

## Functions

### AGS_PLUGIN_PORT_GET_OBJ_MUTEX()

    #define AGS_PLUGIN_PORT_GET_OBJ_MUTEX(obj) (&(((AgsPluginPort *) obj)->obj_mutex))

### ags_plugin_port_get_obj_mutex ()

    GRecMutex *
    ags_plugin_port_get_obj_mutex (AgsPluginPort *plugin_port);

Get object mutex.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the GRecMutex to lock `plugin_port`

Since: 3.1.0

### ags_plugin_port_test_flags ()

    gboolean
    ags_plugin_port_test_flags (AgsPluginPort *plugin_port,
                                AgsPluginPortFlags flags);

Test `flags` to be set on `plugin_port` .

#### Parameters

plugin_port | the AgsPluginPort |
flags | the flags |

#### Returns

`TRUE` if flags are set, else `FALSE`

Since: 3.0.0

### ags_plugin_port_set_flags ()

    void
    ags_plugin_port_set_flags (AgsPluginPort *plugin_port,
                               AgsPluginPortFlags flags);

Set `flags` on `plugin_port` .

#### Parameters

plugin_port | the AgsPluginPort |
flags | the flags |

Since: 3.0.0

### ags_plugin_port_unset_flags ()

    void
    ags_plugin_port_unset_flags (AgsPluginPort *plugin_port,
                                 AgsPluginPortFlags flags);

Unset `flags` on `plugin_port` .

#### Parameters

plugin_port | the AgsPluginPort |
flags | the flags |

Since: 3.0.0

### ags_plugin_port_get_port_index ()

    guint
    ags_plugin_port_get_port_index (AgsPluginPort *plugin_port);

Get port index.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the port index

Since: 3.1.0

### ags_plugin_port_set_port_index ()

    void
    ags_plugin_port_set_port_index (AgsPluginPort *plugin_port,
                                    guint port_index);

Set port index.

#### Parameters

plugin_port | the AgsPluginPort |
port_index | the port index |

Since: 3.1.0

### ags_plugin_port_get_port_name ()

    gchar *
    ags_plugin_port_get_port_name (AgsPluginPort *plugin_port);

Get port name.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the port name

Since: 3.1.0

### ags_plugin_port_set_port_name ()

    void
    ags_plugin_port_set_port_name (AgsPluginPort *plugin_port,
                                   gchar *port_name);

Set port name.

#### Parameters

plugin_port | the AgsPluginPort |
port_name | the port name |

Since: 3.1.0

### ags_plugin_port_get_port_symbol ()

    gchar *
    ags_plugin_port_get_port_symbol (AgsPluginPort *plugin_port);

Get port symbol.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the port symbol

Since: 3.1.0

### ags_plugin_port_set_port_symbol ()

    void
    ags_plugin_port_set_port_symbol (AgsPluginPort *plugin_port,
                                     gchar *port_symbol);

Set port symbol.

#### Parameters

plugin_port | the AgsPluginPort |
port_symbol | the port symbol |

Since: 3.1.0

### ags_plugin_port_get_scale_steps ()

    gint
    ags_plugin_port_get_scale_steps (AgsPluginPort *plugin_port);

Get scale steps.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the scale steps

Since: 3.1.0

### ags_plugin_port_set_scale_steps ()

    void
    ags_plugin_port_set_scale_steps (AgsPluginPort *plugin_port,
                                     gint scale_steps);

Set scale steps.

#### Parameters

plugin_port | the AgsPluginPort |
scale_steps | the scale steps |

Since: 3.1.0

### ags_plugin_port_get_scale_point ()

    gchar **
    ags_plugin_port_get_scale_point (AgsPluginPort *plugin_port);

Get scale point.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the scale point

Since: 3.1.0

### ags_plugin_port_set_scale_point ()

    void
    ags_plugin_port_set_scale_point (AgsPluginPort *plugin_port,
                                     gchar **scale_point);

Set scale point.

#### Parameters

plugin_port | the AgsPluginPort |
scale_point | the scale point |

Since: 3.1.0

### ags_plugin_port_get_scale_value ()

    gdouble *
    ags_plugin_port_get_scale_value (AgsPluginPort *plugin_port);

Get scale value.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the scale value

Since: 3.1.0

### ags_plugin_port_set_scale_value ()

    void
    ags_plugin_port_set_scale_value (AgsPluginPort *plugin_port,
                                     gdouble *scale_value);

Set scale value.

#### Parameters

plugin_port | the AgsPluginPort |
scale_value | the scale value |

Since: 3.1.0

### ags_plugin_port_get_lower_value ()

    GValue *
    ags_plugin_port_get_lower_value (AgsPluginPort *plugin_port);

Get lower value.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the lower value

Since: 3.1.0

### ags_plugin_port_set_lower_value ()

    void
    ags_plugin_port_set_lower_value (AgsPluginPort *plugin_port,
                                     GValue *lower_value);

Set lower value.

#### Parameters

plugin_port | the AgsPluginPort |
lower_value | the lower value |

Since: 3.1.0

### ags_plugin_port_get_upper_value ()

    GValue *
    ags_plugin_port_get_upper_value (AgsPluginPort *plugin_port);

Get upper value.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the upper value

Since: 3.1.0

### ags_plugin_port_set_upper_value ()

    void
    ags_plugin_port_set_upper_value (AgsPluginPort *plugin_port,
                                     GValue *upper_value);

Set upper value.

#### Parameters

plugin_port | the AgsPluginPort |
upper_value | the upper value |

Since: 3.1.0

### ags_plugin_port_get_default_value ()

    GValue *
    ags_plugin_port_get_default_value (AgsPluginPort *plugin_port);

Get default value.

#### Parameters

plugin_port | the AgsPluginPort |

#### Returns

the default value

Since: 3.1.0

### ags_plugin_port_set_default_value ()

    void
    ags_plugin_port_set_default_value (AgsPluginPort *plugin_port,
                                       GValue *default_value);

Set default value.

#### Parameters

plugin_port | the AgsPluginPort |
default_value | the default value |

Since: 3.1.0

### ags_plugin_port_find_symbol ()

    GList *
    ags_plugin_port_find_symbol (GList *plugin_port,
                                 gchar *port_symbol);

Find `port_symbol` within `plugin_port` .

#### Parameters

plugin_port | the GList containing AgsPluginPort. | [element-type AgsAudio.PluginPort][transfer none]
port_symbol | the port symbol |

#### Returns

the matching GList containing AgsPluginPort.

[element-type AgsAudio.PluginPort][transfer none]

Since: 3.0.0

### ags_plugin_port_find_port_index ()

    GList *
    ags_plugin_port_find_port_index (GList *plugin_port,
                                     guint port_index);

Find `port_index` within `plugin_port` .

#### Parameters

plugin_port | the GList containing AgsPluginPort. | [element-type AgsAudio.PluginPort][transfer none]
port_index | the port index |

#### Returns

the matching GList containing AgsPluginPort.

[element-type AgsAudio.PluginPort][transfer none]

Since: 3.0.0

### ags_plugin_port_new ()

    AgsPluginPort *
    ags_plugin_port_new ();

Creates an AgsPluginPort

#### Returns

a new AgsPluginPort

Since: 3.0.0

## Types and Values

### enum AgsPluginPortFlags

Common port attributes.

#### Members

AGS_PLUGIN_PORT_ATOM | atom port |
AGS_PLUGIN_PORT_AUDIO | audio port |
AGS_PLUGIN_PORT_CONTROL | control port |
AGS_PLUGIN_PORT_MIDI | MIDI port |
AGS_PLUGIN_PORT_EVENT | event port |
AGS_PLUGIN_PORT_OUTPUT | is output |
AGS_PLUGIN_PORT_INPUT | is input |
AGS_PLUGIN_PORT_TOGGLED | toggle control |
AGS_PLUGIN_PORT_ENUMERATION | enumerated |
AGS_PLUGIN_PORT_LOGARITHMIC | logarithmic |
AGS_PLUGIN_PORT_INTEGER | integer |
AGS_PLUGIN_PORT_SAMPLERATE | samplerate |
AGS_PLUGIN_PORT_BOUNDED_BELOW | bounded below |
AGS_PLUGIN_PORT_BOUNDED_ABOVE | bounded above |
AGS_PLUGIN_PORT_UI_NOTIFICATION | ui notification |
AGS_PLUGIN_PORT_HIDDEN | hidden port |

## Property Details

### The `“default-value”` property

      “default-value”            gpointer

The default value.

Owner: AgsPluginPort

Flags: Read / Write

Since: 3.0.0

### The `“lower-value”` property

      “lower-value”              gpointer

The lower value.

Owner: AgsPluginPort

Flags: Read / Write

Since: 3.0.0

### The `“port-index”` property

      “port-index”               guint

The assigned port-index.

Owner: AgsPluginPort

Flags: Read / Write

Default value: 0

Since: 3.0.0

### The `“port-name”` property

      “port-name”                char *

The port's name.

Owner: AgsPluginPort

Flags: Read / Write

Default value: NULL

Since: 3.0.0

### The `“port-symbol”` property

      “port-symbol”              char *

The port's symbol.

Owner: AgsPluginPort

Flags: Read / Write

Default value: NULL

Since: 3.0.0

### The `“scale-point”` property

      “scale-point”              gpointer

The scale point string vector.

Owner: AgsPluginPort

Flags: Read

Since: 3.0.0

### The `“scale-steps”` property

      “scale-steps”              int

The number of scale steps.

Owner: AgsPluginPort

Flags: Read / Write

Allowed values: >= -1

Default value: 0

Since: 3.0.0

### The `“scale-value”` property

      “scale-value”              gpointer

The scale value array.

Owner: AgsPluginPort

Flags: Read

Since: 3.0.0

### The `“upper-value”` property

      “upper-value”              gpointer

The upper value.

Owner: AgsPluginPort

Flags: Read / Write

Since: 3.0.0